module App

    class AWS

        VALID_REGIONS = %w(ap-south-1 eu-west-3 eu-west-2 eu-west-1 ap-northeast-2 ap-northeast-1 sa-east-1 ca-central-1 ap-southeast-1 ap-southeast-2 eu-central-1 us-east-1 us-east-2 us-west-1 us-west-2)

        # Returns either ' --profile [profile-name]' or '', depending on whether the machine we're running on has credentials or is an EC2 (which uses IAM roles).
        # @return string
        def self.get_profile_for_cli
            profile_name = App::AWSProfile::get_profile_name
            profile_name.nil? ? '' : " --profile #{profile_name}"
        end

    end

end