module App

    class AWSValidator

        # Helper method to get + validate regions. Probably going to be used in all AWS Cli calls.
        # @return Array
        def self.get_and_validate_regions(region_given)
            regions = App::AWSCli::get_regions
            if region_given
                Blufin::Terminal::error("Invalid AWS region \xe2\x86\x92 #{Blufin::Terminal::format_invalid(region_given)}. Valid regions are:", regions) unless App::AWSValidator::validate_region(region_given)
                @regions << region_given
            else
                @regions = regions
            end
        end

        # Validates AWS region.
        # @return boolean
        def self.validate_region(region)
            if App::Cache::exists?(App::CacheKey::ARRAY_AWS_REGIONS)
                valid_regions = App::Cache::get(App::CacheKey::ARRAY_AWS_REGIONS)
            else
                valid_regions = App::AWSCli::get_regions
            end
            valid_regions.include?(region)
        end

    end

end