module AppCommand

    class CloudFormationDetectDrift < ::Convoy::ActionCommand::Base

        TMP_OUTPUT = '/tmp/execute-output'

        def execute

            begin

                @opts = command_options
                @args = arguments

                @regions = []
                @threads = []

                opts_validate
                opts_routing

            rescue => e

                Blufin::Terminal::print_exception(e)

            end

        end

        def opts_validate

            @regions = App::AWSValidator::get_and_validate_regions(@opts[:region_given])

        end

        def opts_routing
            threads = []
            puts
            stacks = App::AWSCloudFormation::get_stacks
            puts
            system("rm #{TMP_OUTPUT}")
            system("touch #{TMP_OUTPUT}")
            stacks.each do |stack|
                sleep(0.01)
                threads << Thread.new {
                    cmd = "aws cloudformation detect-stack-drift --stack-name #{stack[:name]} --region #{stack[:region]}#{App::AWS::get_profile_for_cli} >> #{TMP_OUTPUT} 2>&1"
                    App::AWSOutputter::output_cli_command(cmd)
                    `#{cmd}`
                }
            end
            sleep(0.1)
            puts
            # Display spinner while waiting for threads to finish.
            Blufin::Terminal::execute_proc("AWS \xe2\x80\x94 Detecting Drift...", Proc.new {
                threads.each { |thread| thread.join }
            })
            output = `cat #{TMP_OUTPUT}`
            output.split("\n").each do |line|
                line = line.strip
                next if line == ''
                next if line =~ /^\{$/
                next if line =~ /^\}$/
                next if line =~ /"StackDriftDetectionId":\s*"[A-Za-z0-9-]+"/
                puts
                puts "\x1B[38;5;196m#{line}\x1B[0m"
            end
            puts
        end

    end

end