module AppCommand

    class Infrastructure < ::Convoy::ActionCommand::Base

        def execute

            begin

                @opts = command_options
                @args = arguments

                @profile = App::AWSProfile::get_profile

                Blufin::Projects::init(@profile[App::AWSProfile::PROJECTS])
                App::Stacks::init(@profile[App::AWSProfile::STACKS])

                opts_validate
                opts_routing

            rescue => e

                Blufin::Terminal::print_exception(e)

            end

        end

        def opts_validate

            @projects = Blufin::Projects::get_projects

            # TODO - REMOVE
            puts @projects.to_yaml

        end

        def opts_routing

            raise RuntimeError, 'Not yet implemented!'

        end

    end

end